module Mongoid
  module TrimmableFields
    extend ActiveSupport::Concern
    
    included do
      before_validation :trim
      class_attribute :trimmable_field_names
      delegate :trimmable_field_names, :to => "self.class"
    end
    
    module ClassMethods
      def trimmable_fields(*field_names)
        self.trimmable_field_names = field_names
      end
    end
    
  private  
    def trim
      trimmable_field_names.each do |field|
      	self[field] = self[field].strip if self[field].respond_to?(:strip)    
      end  
    end
  end
end